function Fst = F_s_t(Y,expW,delta,X,n)

t = 0.01:0.01:1;
Fst = zeros(length(t),length(t)); % 100 because this is a 10x10 grids

[YY,I]=sort(Y);
expWW = expW(I);
deltaa = delta(I);
XX = X(I);
Xs = zeros(n,length(t));

for i = 1:n
    XXX=chebfun(XX(i));
    Xs(i,:) = XXX(t);
end

Xt = Xs;

Lambda = zeros(n,1);

for ss = 1:100
    for tt = ss:100 % symmetric, so only the upper trianglar needs calculation
        
        expWXsXt = expWW.*(Xs(:,ss).*Xt(:,tt));
        expWXs = expWW.*Xs(:,ss);
        expWXt = expWW.*Xt(:,tt);
        
        Ytk = (YY >= YY(1));
        Lambda(1) = (1/sum(Ytk.*expWW))*deltaa(1);
        Fst(ss,tt) = (sum(Ytk.*expWXsXt)/sum(Ytk.*expWW) - ...
            (sum(Ytk.*expWXs)/sum(Ytk.*expWW))* ...
            (sum(Ytk.*expWXt)/sum(Ytk.*expWW))) * ...
            mean(Ytk.*expWW) * Lambda(1);
        
        for k = 2:n
            
            if(YY(k) < 1)
                
                Ytk = (YY >= YY(k));
                Lambda(k) = Lambda(k-1) + (1/sum(Ytk.*expWW))*deltaa(k);
                
                Fst(ss,tt) = Fst(ss,tt) + (sum(Ytk.*expWXsXt)/sum(Ytk.*expWW) - ...
                    (sum(Ytk.*expWXs)/sum(Ytk.*expWW))* ...
                    (sum(Ytk.*expWXt)/sum(Ytk.*expWW))) * ...
                    mean(Ytk.*expWW) * (Lambda(k)-Lambda(k-1));
            end
        end

        Fst(tt,ss) = Fst(ss,tt);
    end
end




